//========================================
//==	PEACH-IpR}hvZbT	==
//==					==
//========================================

#include "ctype.h"
#include "cstdef.h"
#include "sio.h"
extern void printf(unsigned char *string,...);	// unsigned int);
extern void puts(unsigned char *string);
extern void putc(unsigned char c);
extern unsigned char	exitreq;

static unsigned char	*sptr;
unsigned char	cmdsts;

#define	CMD_NULL	0
#define	CMD_BYTE	1
#define	CMD_EXIT	2
#define	CMD_LENGTH	3
#define	CMD_EQUAL	4
#define	CMD_GOTO	5
#define	CMD_XMODEM	6
#define	CMD_ERASE	7
#define	CMD_PROGRAM	8
#define	CMD_CLS		9
#define	CMD_HELP	10

#pragma dataseg ("RODATA")

unsigned char *token[] = {	// R}he[u
	"",
	"BYTE",
	"EXIT",
	"LENGTH",
	"=",
	"GOTO",
	"XMODEM",
	"ERASE",
	"PROGRAM",
	"CLS",
	"HELP"
};
unsigned char *errmsg[] = {	// G[bZ[We[u
	"",
	"?VALUE\r\n",
	"?CMD\r\n",
	"!BREAK\r\n"
};

const unsigned char TOKENSIZE = (sizeof(token) / sizeof(unsigned char *) );
unsigned char tokennum;

//----------------
//-- r	--
//----------------
unsigned char scmp(unsigned char *s, unsigned char *d)
{
	unsigned char c;
	c = 0;
	while (*s == *d) {
		if (*d == EOS) {
			return(c);
		}
		s++;
		d++;
		c++;
	}
	if (*d == EOS)
		return(c);
	return(0);
}

//------------------------------------------------
//--	Xy[XȊO̕܂ŃXLbv	--
//------------------------------------------------
void skipspace(void)
{
	while (isspace(*sptr))
		sptr++;
}

//--------------------------------
//-- R}hR[h̎擾	--
//--------------------------------
unsigned char get_token(void)
{
	unsigned char tokenlen;
	skipspace();
	for (tokennum = TOKENSIZE-1; tokennum>0; tokennum--) {
		tokenlen = scmp(sptr, token[tokennum]);
		if (tokenlen != 0)
			break;
	}
	return(tokenlen);
}

//----------------------------------------
//-- '0'`'9'A'A'`'F'0x0`0xFɕϊ	--
//----------------------------------------
unsigned char hexatoi(unsigned char c)
{
	if ((c >= '0') && (c <= '9'))
		return(c - '0');
	if ((c >= 'A') && (c <= 'F'))
		return(c - 'A' + 10);
	if ((c >= 'a') && (c <= 'f'))
		return(c - 'a' + 10);
	return (0);
}

//--------------------------------
//--	16i񌅂̎擾		--
//-- 擪̃[TvX͏ȗ	--
//--------------------------------
unsigned char get2hex()
{
	unsigned char retdat;
	skipspace();
	if (!(isxdigit(*sptr))) {	// 擪16iłȂG[I
		cmdsts = E_ERRVAL;
		return(0);
	}
	retdat = hexatoi(*sptr++);	// ꌅڂ̎擾
	if (isxdigit(*sptr))		// 񌅖ڂΎ擾
		retdat = retdat * 0x10 + hexatoi(*sptr++);
	return(retdat);
}

//--------------------------------
//--	16il̎擾		--
//-- 擪̃[TvX͏ȗ	--
//--------------------------------
unsigned int get4hex()
{
	unsigned char	i;
	unsigned int	retdat;
	skipspace();
	if (!(isxdigit(*sptr))) {	// 擪16iłȂG[I
		cmdsts = E_ERRVAL;
		return(0);
	}
	retdat = hexatoi(*sptr++);	// ꌅڂ̎擾
	for (i=0; i<3; i++) {		// 񌅖ڈȍ~̎擾
		if (!(isxdigit(*sptr)))
			break;
		retdat = retdat * 0x10 + hexatoi(*sptr++);
	}
	return(retdat);
}

//------------------------
//-- BYTER}h̏	--
//------------------------
void exec_byte(void)
{
	unsigned int  len;
	unsigned char *p,*q;
	unsigned char dlen,wdat;
	p = (unsigned char *)get4hex();	// AhX
	if (cmdsts != E_READY)
		return;
	dlen = get_token();
	if (tokennum == CMD_LENGTH) {	// w肪
		sptr += dlen;
		len = get4hex();	// f[^擾
		if (cmdsts != E_READY)
			return;
	} else	len = 1;		// w肪ȂȂPoCg
	dlen = get_token();
	if (tokennum == CMD_EQUAL) {	// = if[^Cg[hj
		sptr += dlen;
		wdat = get2hex();	// ŏ̏f[^
		if (cmdsts != E_READY)
			return;
		if (len > 1) {		// w肪΃f[^FILL[h
			while(len--)
				*p++ = wdat;
		} else {		// w肪Ȃ玟̔Ԓnp̃f[^`FbN
			do {		// 16iȊO̕܂ŏ
				*p++ = wdat;
				wdat = get2hex();
			} while (cmdsts == E_READY);
			cmdsts = E_READY;
		}
	} else {			// =i_v[hj
		q = p;
		dlen = 0;
		while(len && (cmdsts == E_READY)) {		// łcmdsts`FbN̓L[{[h́ObiBreakjΉ
			printf("\nBYTE %04x=",(unsigned int)p);	// AhX\
			dlen = (len > 16) ? 16 : len;		// c肪16oCg葽16oCgAȉȂTCY\
			len -= dlen;				// coCg炷
			for (wdat = 0; wdat < dlen; wdat++)	// 16iŃf[^_v
				printf(" %02x",*p++);
			while(wdat++ < 16)			// 16oCgȉȂASCII_v܂ŃXy[XŖ߂
				puts("   ");
			puts(" /");				// ASCII_vƂ̋؂
			while(dlen--) {				// 16i_vƓ
				if (isprint(*q))		// ASCII\\ȕȂ
					printf("%c",*q);	// \
				else	putc('.');		// \s\ȂhDh\
				q++;
			}
		}
		puts("\r\n");
	}

}

//----------------------------------------
//--	 GOTOR}h̏		--
//--@ۂɂ̓Wvł͂ȂR[	--
//--@Ȃ̂ŁA^[Ă邱Ƃ	--
//----------------------------------------
void (*fp)(void);
void exec_goto()
{
	fp = (void *())(get4hex());	// ^ꂽAhX擾
	if (cmdsts != E_READY)		// 16iłȂȂG[
		return;
	__asm__("php");			// tOҔ
	__asm__("sei");			// ֎~
	fp();				// wԒnR[
	__asm__("plp");
}

//----------------------------------------
//--SIOi16550jւ̃f[^ZbgiMj--
//--@Mobt@GveBȂ̂	--
//--@mFĂf[^WX^ɏ	--
//----------------------------------------
static void put_sio(unsigned char c)
{
	while(!(SIO_LSR & LSR_THRE))	// Mobt@ɂȂ܂ő҂
		;
	SIO_THR = c;			// f[^Zbg
}

//----------------------------------------
//--SIOi16550j̃f[^擾iMj--
//-- Mf[^fBtO	--
//-- f[^WX^ǂ		--
//----------------------------------------
static unsigned char get_sio()
{
	while(!(SIO_LSR & LSR_DR))
		;
	return(SIO_RBR);
}

//----------------------------------------
//--SIOi16550j̎Mf[^fBtO--
//--@̃`FbN			--
//--@`FbNŃf[^擾͂Ȃ	--
//----------------------------------------
static unsigned char chk_siorx()
{
	return (SIO_LSR & LSR_DR);
}

//----------------------------------------
//-- XMODEMvgRɂoCi	--
//-- f[^̎M			--
//-- w肵AhXAi[	--
//-- VIvVt		--
//-- 擪+$0A`+0FxN^ƌȂ	--
//-- RAM̖AhXɃRs[	--
//----------------------------------------
void exec_xmodem()
{
	unsigned int i;
	unsigned char c,vcp;
	unsigned char *p;
	unsigned char *q;
	p = (unsigned char *)get4hex();
	q = p;
	if (cmdsts != E_READY)
		return;
	skipspace();
	if (*sptr == 'V')
		vcp = 1;
	else	vcp = 0;
	__asm__("php");	// Push Processor Status register
	__asm__("sei");	// Set Interrupt Mask (Disable Interrupt)
	i = 0;
	while(1) {			// ]Jn҂
		if (i == 0) {
			put_sio(NAK);	// ]X^[gv
			i = 30000;
		} else	i--;
		c = chk_siorx();
		if (c != 0) {
			c = get_sio();	// SOH
			if (c == SOH)
				break;
		}
	}
	do {
		c = get_sio();	// BLK#
		c = get_sio();	// ~BLK#
		for (c=0; c<128; c++) {
			*p++ = get_sio();
		}
		c = get_sio();	// Checksum
		put_sio(ACK);
		c = get_sio();	// ̃t[̊Jn܂͏I
	} while(c == SOH);
	put_sio(ACK);
	__asm__("plp");	// Pop Processor Status register
	if (vcp) {	// Vector Copy Mode
		p = (unsigned char *)0x3ffa;
		q += 0xa;
		for (c=0; c<6; c++)
			*p++ = *q++;
	}
}

//----------------------------------------
//-- tbṼ`bvC[X	--
//-- R}hoA0xFFǂ߂܂	--
//-- ҂B				--
//-- C[Xs̓rbg7'0'ɂȂ	--
//-- Əς݃f[^ǂ߂	--
//-- ̂0xffǂݏo邱ƂɂȂ	--
//----------------------------------------
#define	FL_2AAA	*(unsigned char *)0x6aaa
#define	FL_5555	*(unsigned char *)0x5555
void exec_flerase(void)
{
	FL_5555 = 0xaa;			// `bvC[XR}h
	FL_2AAA = 0x55;
	FL_5555 = 0x80;
	FL_5555 = 0xaa;
	FL_2AAA = 0x55;
	FL_5555 = 0x10;
	while(FL_5555 != 0xff)		// C[X҂
		;
}

//----------------------------------------
//-- tbVւ̏		--
//-- $D000`FFFF̃f[^$5000`7FFF	--
//-- ̃tbVɏ	--
//-- R}hoĂPoCgs	--
//-- ͏f[^ǂݏo邩mF	--
//-- s̓rbg7f[^	--
//-- ̔]ƂȂA܂DQ5[h	--
//-- тɔ]B			--
//-- 񂾃f[^Ɠlǂ߂	--
//-- ܂ő҂ƂPȎƂ	--
//----------------------------------------
void exec_flprogram(void)
{
	unsigned int i;
	unsigned char *s, *d;
	puts("\r\n");
	s = (unsigned char *)0xd000;
	d = (unsigned char *)0x5000;
	for (i=0; i<0x3000; i++) {	// $D000`$FFFFΏ
		if (!(i & 0xff))
			printf("  %02x",(i >> 8));
		FL_5555 = 0xaa;		// CgR}h
		FL_2AAA = 0x55;
		FL_5555 = 0xa0;
		*d = *s;		// Cgf[^
		while(*d != *s)		// lǂݏo܂ő҂
			;
		d++;
		s++;
	}
}

//----------------------------------------
//-- R}hOƂ̂߂	--
//-- R}he[u\		--
//----------------------------------------
void exec_help(void)
{
	unsigned char i;
	puts("\r\n");
	for (i = 1; i < TOKENSIZE; i++)
		printf("[%-7s]\n",token[i]);
}


//----------------------------------------
//-- R}h̃Gg		--
//----------------------------------------
void exec_cmd(unsigned char *s)
{
	unsigned int cmdlen;
	sptr = s;
	cmdsts = E_READY;		// Xe[^XREADYɂĂX^[g
	cmdlen = get_token();		// g[NiR}hj擾
	switch(tokennum) {
		case	CMD_NULL:
				cmdsts = E_ERRCMD;
				break;
		case	CMD_BYTE:
				sptr += cmdlen;
				exec_byte();
				break;
		case	CMD_EXIT:
				exitreq = 1;
				break;
		case	CMD_GOTO:
				sptr += cmdlen;
				exec_goto();
				break;
		case	CMD_XMODEM:
				sptr += cmdlen;
				exec_xmodem();
				break;
		case	CMD_ERASE:
				sptr += cmdlen;
				exec_flerase();
				break;
		case	CMD_PROGRAM:
				sptr += cmdlen;
				exec_flprogram();
				break;
		case	CMD_CLS:
				putc(CLR);
				break;
		case	CMD_HELP:
				exec_help();
				break;
		default:	cmdsts = E_ERRCMD;
				break;
	}
	if (cmdsts != E_READY) {
		puts(errmsg[cmdsts]);
	}
}
